# coding: utf-8

"""
    Component Database API

    The API that provides access to Component Database data.  # noqa: E501

    The version of the OpenAPI document: 3.8.0
    Contact: djarosz@anl.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from cdbApi.configuration import Configuration


class UserGroup(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'description': 'str',
        'user_info_list': 'list[UserInfo]',
        'list_list': 'list[ListTbl]',
        'user_role_list': 'list[UserRole]',
        'entity_info_list': 'list[EntityInfo]',
        'user_group_setting_list': 'list[UserGroupSetting]',
        'item_element_lists': 'list[ListTbl]',
        'settings_modification_date': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'user_info_list': 'userInfoList',
        'list_list': 'listList',
        'user_role_list': 'userRoleList',
        'entity_info_list': 'entityInfoList',
        'user_group_setting_list': 'userGroupSettingList',
        'item_element_lists': 'itemElementLists',
        'settings_modification_date': 'settingsModificationDate'
    }

    def __init__(self, id=None, name=None, description=None, user_info_list=None, list_list=None, user_role_list=None, entity_info_list=None, user_group_setting_list=None, item_element_lists=None, settings_modification_date=None, local_vars_configuration=None):  # noqa: E501
        """UserGroup - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._description = None
        self._user_info_list = None
        self._list_list = None
        self._user_role_list = None
        self._entity_info_list = None
        self._user_group_setting_list = None
        self._item_element_lists = None
        self._settings_modification_date = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        if user_info_list is not None:
            self.user_info_list = user_info_list
        if list_list is not None:
            self.list_list = list_list
        if user_role_list is not None:
            self.user_role_list = user_role_list
        if entity_info_list is not None:
            self.entity_info_list = entity_info_list
        if user_group_setting_list is not None:
            self.user_group_setting_list = user_group_setting_list
        if item_element_lists is not None:
            self.item_element_lists = item_element_lists
        if settings_modification_date is not None:
            self.settings_modification_date = settings_modification_date

    @property
    def id(self):
        """Gets the id of this UserGroup.  # noqa: E501


        :return: The id of this UserGroup.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserGroup.


        :param id: The id of this UserGroup.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this UserGroup.  # noqa: E501


        :return: The name of this UserGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserGroup.


        :param name: The name of this UserGroup.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 64):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this UserGroup.  # noqa: E501


        :return: The description of this UserGroup.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UserGroup.


        :param description: The description of this UserGroup.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 256):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501

        self._description = description

    @property
    def user_info_list(self):
        """Gets the user_info_list of this UserGroup.  # noqa: E501


        :return: The user_info_list of this UserGroup.  # noqa: E501
        :rtype: list[UserInfo]
        """
        return self._user_info_list

    @user_info_list.setter
    def user_info_list(self, user_info_list):
        """Sets the user_info_list of this UserGroup.


        :param user_info_list: The user_info_list of this UserGroup.  # noqa: E501
        :type: list[UserInfo]
        """

        self._user_info_list = user_info_list

    @property
    def list_list(self):
        """Gets the list_list of this UserGroup.  # noqa: E501


        :return: The list_list of this UserGroup.  # noqa: E501
        :rtype: list[ListTbl]
        """
        return self._list_list

    @list_list.setter
    def list_list(self, list_list):
        """Sets the list_list of this UserGroup.


        :param list_list: The list_list of this UserGroup.  # noqa: E501
        :type: list[ListTbl]
        """

        self._list_list = list_list

    @property
    def user_role_list(self):
        """Gets the user_role_list of this UserGroup.  # noqa: E501


        :return: The user_role_list of this UserGroup.  # noqa: E501
        :rtype: list[UserRole]
        """
        return self._user_role_list

    @user_role_list.setter
    def user_role_list(self, user_role_list):
        """Sets the user_role_list of this UserGroup.


        :param user_role_list: The user_role_list of this UserGroup.  # noqa: E501
        :type: list[UserRole]
        """

        self._user_role_list = user_role_list

    @property
    def entity_info_list(self):
        """Gets the entity_info_list of this UserGroup.  # noqa: E501


        :return: The entity_info_list of this UserGroup.  # noqa: E501
        :rtype: list[EntityInfo]
        """
        return self._entity_info_list

    @entity_info_list.setter
    def entity_info_list(self, entity_info_list):
        """Sets the entity_info_list of this UserGroup.


        :param entity_info_list: The entity_info_list of this UserGroup.  # noqa: E501
        :type: list[EntityInfo]
        """

        self._entity_info_list = entity_info_list

    @property
    def user_group_setting_list(self):
        """Gets the user_group_setting_list of this UserGroup.  # noqa: E501


        :return: The user_group_setting_list of this UserGroup.  # noqa: E501
        :rtype: list[UserGroupSetting]
        """
        return self._user_group_setting_list

    @user_group_setting_list.setter
    def user_group_setting_list(self, user_group_setting_list):
        """Sets the user_group_setting_list of this UserGroup.


        :param user_group_setting_list: The user_group_setting_list of this UserGroup.  # noqa: E501
        :type: list[UserGroupSetting]
        """

        self._user_group_setting_list = user_group_setting_list

    @property
    def item_element_lists(self):
        """Gets the item_element_lists of this UserGroup.  # noqa: E501


        :return: The item_element_lists of this UserGroup.  # noqa: E501
        :rtype: list[ListTbl]
        """
        return self._item_element_lists

    @item_element_lists.setter
    def item_element_lists(self, item_element_lists):
        """Sets the item_element_lists of this UserGroup.


        :param item_element_lists: The item_element_lists of this UserGroup.  # noqa: E501
        :type: list[ListTbl]
        """

        self._item_element_lists = item_element_lists

    @property
    def settings_modification_date(self):
        """Gets the settings_modification_date of this UserGroup.  # noqa: E501


        :return: The settings_modification_date of this UserGroup.  # noqa: E501
        :rtype: datetime
        """
        return self._settings_modification_date

    @settings_modification_date.setter
    def settings_modification_date(self, settings_modification_date):
        """Sets the settings_modification_date of this UserGroup.


        :param settings_modification_date: The settings_modification_date of this UserGroup.  # noqa: E501
        :type: datetime
        """

        self._settings_modification_date = settings_modification_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserGroup):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserGroup):
            return True

        return self.to_dict() != other.to_dict()
